//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2021 - Stephane MOTTELET
//
// This file is hereby licensed under the terms of the GNU GPL v3.0,
// For more information, see the COPYING file which you should have received
//
//--------------------------------------------------------------------------

#ifndef _SUNDIALSBRIDGE_HXX_
#define _SUNDIALSBRIDGE_HXX_

int SUNDIALSEvent(realtype t, N_Vector y, realtype *gout, void *pManager);
int SUNDIALSImplEvent(realtype t, N_Vector N_VectorY, N_Vector N_VectorYp, realtype *pdblOut, void *pManager);
int SUNDIALSIntCb(realtype t, N_Vector N_VectorY, N_Vector N_VectorYp, wchar_t *pwstFlag, void *pManager);

void SUNDIALSErrHandler(int error_code, const char *module, const char *function, char *msg, void *pManager);

typedef int (*SUNDIALSDynIntCb)(int *n, double *t, double *y, int *);
typedef int (*SUNDIALSDynIntCbWithPar)(int *n, double *t, double *y, int*, double *pdblPar);
typedef void (*SUNDIALSDynEvent)(int *n, double *t, double *y, int *ng, double *, int *dir, int *term);
typedef void (*SUNDIALSDynEventWithPar)(int *n, double *t, double *y, int *ng, double *, int *dir, int *term, double *);

typedef int (*SUNDIALSDynImplIntCb)(int *n, double *t, double *y, double *yp, int *);
typedef int (*SUNDIALSDynImplIntCbWithPar)(int *n, double *t, double *y, double *p, int*, double *pdblPar);
typedef void (*SUNDIALSDynImplEvent)(int *n, double *t, double *y, double *yp, int *ng, double *, int *dir, int *term);
typedef void (*SUNDIALSDynImplEventWithPar)(int *n, double *t, double *y, double *yp, int *ng, double *, int *dir, int *term, double *pdblPar);

#endif
