//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2021 - Stephane MOTTELET
//
// This file is hereby licensed under the terms of the GNU GPL v2.0,
// For more information, see the COPYING file which you should have received
//
//--------------------------------------------------------------------------

path_builder = get_absolute_file_path('builder_gateway_cpp.sce');
path_root = fullpath(fullfile(path_builder,'..','..'));
cd(path_builder);

TOOLBOX_NAME = "sci_sundials";

files_in_src = [
"OdeManagerParse.cpp"
"OdeManagerCompute.cpp"
"OdeManagerHelpers.cpp"
"OdeManagerInit.cpp"
"OdeManagerSolve.cpp"
"OdeManagerCompute.cpp"
"SUNDIALSBridge.cpp"
"CVODEBridge.cpp"
"CVODEManager.cpp"
"IDAManager.cpp"
"IDABridge.cpp"
"odeparameters.cpp"
];

for i=1:size(files_in_src,"*")
    copyfile(fullfile("..","..","src","cpp",files_in_src(i)),files_in_src(i));
end

files_to_compile = [files_in_src
"sci_cvode.cpp"
"sci_ida.cpp"
"sci_percent_odeSolution.cpp"];

SUNDIALS = fullfile(SCI,'modules','scicos','src','scicos_sundials');
cflags = ' -I' + fullfile(path_root,'includes');
cflags = cflags + " -I"+fullfile(SUNDIALS,"src")
cflags = cflags + " -I"+fullfile(SUNDIALS,"include")
libs = ""
ldflags = "";

if getos() == "Windows" then
    libs = [fullfile("SUNDIALS","scicos_sundials")
            fullfile(SCI,"bin","scicos_sundials")]
    ldflags = "";
end

gateways = [
"cvode", "sci_cvode", "cppsciopt"
"ida", "sci_ida_solve", "cppsciopt"
"%_odeSolution_clear", "sci_percent_odeSolution_clear", "cppsci"
"%_odeSolution_e", "sci_percent_odeSolution_e", "cppsci"]

tbx_build_gateway(TOOLBOX_NAME,gateways,files_to_compile, path_builder, libs, ldflags, cflags);
